<?php 
   /*
    Copyright 2012  James Welch 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */

/* the Lookups pages */
class RateBeer_Lookups {
  var $state_names; 
  var $country_names;
  var $brewer_types;
  var $beer_styles;
  var $beer_seasons;
  
  function get_beer_season( $BeerSeasonID ) {
    if (empty($beer_seasons) ) {
      $brewer_types = array(
        1	=> 'Winter',
        2	=> 'Spring',
        3	=> 'Summer',
        4	=> 'Autumn',
        5	=> 'Special',
        6	=> 'Series');
    }
         
    if (array_key_exists($BeerSeasonID , $beer_seasons)) {
      return $beer_seasons[ $BeerSeasonID  ];      
    }
    
    return 'NOT FOUND';
  }


  function get_beer_style( $BeerStyleID ) {
    if (empty($beer_styles) ) {
      $beer_styles = array(
        71 => 'Abbey Dubbel',
        72 => 'Abbey Tripel',
        80 => 'Abt/Quadrupel',
        2 => 'Altbier',
        53 => 'Amber Ale',
        36 => 'American Dark Lager',
        18 => 'American Pale Ale',
        64 => 'American Strong Ale', 
        63 => 'Baltic Porter',
        11 => 'Barley Wine',
        12 => 'Belgian Ale',
        13 => 'Belgian Strong Ale',
        48 => 'Belgian White &#40;Witbier&#41;',
        61 => 'Berliner Weisse',
        58 => 'Bire de Garde',
        20 => 'Bitter',
        114 => 'Black IPA',
        31 => 'Bohemian Pilsener',
        15 => 'Brown Ale',
        42 => 'California Common',
        10 => 'Cider',
        30 => 'Classic German Pilsener',
        35 => 'Cream Ale',
        26 => 'Doppelbock',
        60 => 'Dortmunder/Helles',
        22 => 'Dry Stout',
        28 => 'Dunkel',
        100 => 'Dunkelweizen',
        9 => 'Dunkler Bock',
        27 => 'Eisbock',
        16 => 'English Pale Ale',
        56 => 'English Strong Ale',
        79 => 'Foreign Stout',
        40 => 'Fruit Beer',
        7 => 'German Hefeweizen',
        82 => 'German Kristallweizen',
        54 => 'Golden Ale/Blond Ale',
        105 => 'Heller Bock',
        112 => 'Ice Cider/Perry',
        24 => 'Imperial Stout',
        81 => 'Imperial/Double IPA',
        113 => 'Imperial/Strong Porter',
        17 => 'India Pale Ale &#40;IPA&#41;',
        62 => 'Irish Ale',
        39 => 'Klsch',
        77 => 'Lambic - Faro',
        14 => 'Lambic - Fruit',
        73 => 'Lambic - Gueuze',
        78 => 'Lambic - Unblended',
        75 => 'Low Alcohol',
        8 => 'Malt Liquor',
        44 => 'Mead',
        55 => 'Mild Ale',
        37 => 'Oktoberfest/Mrzen',
        76 => 'Old Ale',
        3 => 'Pale Lager',
        107 => 'Perry',
        4 => 'Pilsener',
        5 => 'Porter',
        101 => 'Premium Bitter/ESB',
        103 => 'Premium Lager',
        45 => 'Saison',
        87 => 'Sak - Daiginjo',
        89 => 'Sak - Futsu-shu',
        91 => 'Sak - Genshu',
        86 => 'Sak - Ginjo',
        85 => 'Sak - Honjozo',
        94 => 'Sak - Infused',
        84 => 'Sak - Junmai',
        92 => 'Sak - Koshu',
        90 => 'Sak - Namasak',
        93 => 'Sak - Nigori',
        95 => 'Sak - Taru',
        88 => 'Sak - Tokubetsu',
        29 => 'Schwarzbier',
        102 => 'Scotch Ale',
        21 => 'Scottish Ale',
        41 => 'Smoked',
        52 => 'Sour Ale/Wild Ale',
        106 => 'Specialty Grain',
        57 => 'Spice/Herb/Vegetable',
        6 => 'Stout',
        65 => 'Strong Pale Lager/Imperial Pils',
        23 => 'Sweet Stout',
        59 => 'Traditional Ale',
        43 => 'Vienna',
        25 => 'Weizen Bock',
        19 => 'Wheat Ale',
        74 => 'Zwickel/Keller/Landbier');
    }
         
    if (array_key_exists($BeerStyleID , $beer_styles)) {
      return $beer_styles[ $BeerStyleID  ];      
    }
    
    return 'NOT FOUND';
  }
  
  function get_brewer_type( $BrewerTypeID ) {
    if (empty($brewer_types) ) {
      $brewer_types = array(
        1	=> 'Commercial Brewery',
        2	=> 'Microbrewery',
        3	=> 'Brew Pub',
        4	=> 'Brew Pub/Brewery',
        5	=> 'Contract Brewer',
        6	=> 'Meadery',                         
        7	=> 'Sake Producer',
        8	=> 'Cidery',                          
        9	=> 'Client Brewer');
    }
         
    if (array_key_exists($BrewerTypeID , $brewer_types)) {
      return $brewer_types[ $BrewerTypeID  ];      
    }
    
    return 'NOT FOUND';
  }
  
  function get_state_name( $BrewerStateID ){
    if( empty( $state_names ) ) {
        $state_names = array(
          0 => '',
          1 => 'Alabama',
          2 => 'Alaska',
          3 => 'Arizona',
          4 => 'Arkansas',
          5 => 'California', 
          6 => 'Colorado',
          7 => 'Connecticut',
          8 => 'Delaware',
          9 => 'Florida',
          10 => 'Georgia',
          11 => 'Hawaii',
          12 => 'Idaho',
          13 => 'Indiana', 
          14 => 'Illinois',
          15 => 'Iowa',
          16 => 'Kansas',
          17 => 'Kentucky',
          18 => 'Louisiana',
          19 => 'Maine',
          20 => 'Maryland',
          21 => 'Massachusetts',
          22 => 'Michigan',
          23 => 'Minnesota',
          24 => 'Mississippi',
          25 => 'Missouri',
          26 => 'Montana',
          27 => 'Nebraska',
          28 => 'Nevada',
          29 => 'New Hampshire',
          30 => 'New Jersey',
          31 => 'New Mexico',
          32 => 'New York',
          33 => 'North Carolina',
          34 => 'North Dakota',
          35 => 'Ohio',
          36 => 'Oklahoma',
          37 => 'Oregon',
          38 => 'Pennsylvania',
          39 => 'Rhode Island',
          40 => 'South Carolina',
          41 => 'South Dakota',
          42 => 'Tennessee',
          43 => 'Texas',
          44 => 'Utah',
          45 => 'Vermont',
          46 => 'Virginia',
          47 => 'Washington', 
          48 => 'Washington DC',
          49 => 'West Virginia',
          50 => 'Wisconsin',
          51 => 'Wyoming',
          52 => 'Alberta',
          53 => 'British Columbia',
          54 => 'Manitoba',
          55 => 'New Brunswick',
          56 => 'Newfoundland',
          57 => 'Nova Scotia',
          58 => 'Northwest Territories',
          59 => 'Ontario',
          60 => 'Prince Edward Island',
          61 => 'Quebec',
          62 => 'Saskatchewan',
          63 => 'Yukon',
          64 => 'Nunavut', 
          65 => 'Bedfordshire',
          66 => 'Berkshire',
          67 => 'Buckinghamshire',
          68 => 'Cambridgeshire',
          69 => 'Cheshire',
          70 => 'Cornwall',
          71 => 'Cumbria',
          72 => 'Derbyshire', 
          73 => 'Devon',
          74 => 'Dorset',
          75 => 'Durham',
          76 => 'East Sussex',
          77 => 'East Yorkshire',
          78 => 'Essex',
          79 => 'Greater London',
          80 => 'Greater Manchester',
          81 => 'Gloucestershire',
          82 => 'Hampshire',
          83 => 'Herefordshire',
          84 => 'Hertfordshire',
          85 => 'Isle Of Wight',
          86 => 'Kent',
          87 => 'Lancashire', 
          88 => 'Leicestershire',
          89 => 'Lincolnshire',
          90 => 'Merseyside', 
          91 => 'North Yorkshire',
          92 => 'Norfolk', 
          93 => 'Northamptonshire',
          94 => 'Northumberland',
          95 => 'Nottinghamshire',
          96 => 'Oxfordshire',
          97 => 'Rutland', 
          98 => 'South Yorkshire',
          99 => 'Shropshire', 
          100 => 'Somerset',
          101 => 'Staffordshire', 
          102 => 'Suffolk', 
          103 => 'Surrey',
          104 => 'Tyne &amp; Wear',
          105 => 'West Sussex',
          106 => 'West Yorkshire',
          107 => 'Warwickshire',
          108 => 'West Midlands', 
          109 => 'Wiltshire',
          110 => 'Worcestershire',
          111 => 'Baden-Wrttemberg',
          112 => 'Bavaria', 
          113 => 'Berlin',
          114 => 'Brandenburg',
          115 => 'Bremen',
          116 => 'Hamburg', 
          117 => 'Hesse',
          118 => 'Mecklenburg-Vorpommern', 
          119 => 'Lower Saxony',
          120 => 'North Rhine-Westphalia', 
          121 => 'Rhineland-Palatinate',
          122 => 'Saarland',
          123 => 'Saxony',
          124 => 'Saxony-Anhalt', 
          125 => 'Schleswig-Holstein',
          126 => 'Thuringia');
    }
    
    if (array_key_exists($BrewerStateID , $state_names)) {
      return $state_names[ $BrewerStateID  ];      
    }
    
    return 'NOT FOUND';
  }
  
   function get_country_name( $BrewerCountryID ){
    if( empty( $country_names ) ) {
        $country_names = array(  
        39 => 'Canada',
        240 => 'England',
        213 => 'United States', 
        1 => 'Afghanistan',
        2 => 'Albania',
        4 => 'Algeria',
        5 => 'American Samoa',
        6 => 'Andorra',
        7 => 'Angola',
        8 => 'Anguilla',
        9 => 'Antigua & Barbuda',
        10 => 'Argentina',
        11 => 'Armenia',
        12 => 'Aruba',
        13 => 'Ascension Island',
        14 => 'Australia',
        15 => 'Austria',
        16 => 'Azerbaijan',
        17 => 'Bahamas',
        18 => 'Bahrain',
        19 => 'Bangladesh',
        20 => 'Barbados',
        22 => 'Belarus',
        23 => 'Belgium',
        24 => 'Belize',
        25 => 'Benin',
        26 => 'Bermuda',
        27 => 'Bhutan',
        28 => 'Bolivia',
        29 => 'Bosnia',
        30 => 'Botswana',
        31 => 'Brazil',
        32 => 'British Virgin Islands',
        33 => 'Brunei',
        34 => 'Bulgaria',
        35 => 'Burkina Faso',
        36 => 'Burundi',
        37 => 'Cambodia',
        38 => 'Cameroon',
        40 => 'Cape Verde Islands',
        41 => 'Cayman Islands',
        42 => 'Central African Republic',
        233 => 'Ceuta',
        43 => 'Chad',
        44 => 'Chile',
        45 => 'China',
        46 => 'Christmas Island',
        47 => 'Cocos-Keeling Islands',
        48 => 'Colombia',
        49 => 'Comoros',
        50 => 'Congo',
        51 => 'Cook Islands',
        52 => 'Costa Rica',
        53 => 'Croatia',
        54 => 'Cuba',
        55 => 'Cyprus',
        56 => 'Czech Republic',
        57 => 'Dem Rep of Congo',
        58 => 'Denmark',
        59 => 'Diego Garcia',
        60 => 'Djibouti',
        61 => 'Dominica',
        62 => 'Dominican Republic',
        236 => 'East Timor',
        63 => 'Ecuador',
        64 => 'Egypt',
        65 => 'El Salvador',
        240 => 'England',
        66 => 'Equatorial Guinea',
        243 => 'Eritrea',
        67 => 'Estonia',
        68 => 'Ethiopia',
        69 => 'Falkland Islands',
        244 => 'Faroe Islands',
        70 => 'Fiji Islands',
        71 => 'Finland',
        72 => 'France',
        74 => 'French Guiana',
        75 => 'French Polynesia',
        76 => 'Gabon',
        77 => 'Gambia',
        78 => 'Georgia',
        79 => 'Germany',
        80 => 'Ghana',
        81 => 'Gibraltar',
        82 => 'Greece',
        83 => 'Greenland',
        84 => 'Grenada',
        85 => 'Guadeloupe',
        86 => 'Guam',
        88 => 'Guatemala',
        225 => 'Guernsey',
        89 => 'Guinea',
        253 => 'Guinea-Bissau',
        90 => 'Guyana',
        91 => 'Haiti',
        92 => 'Honduras',
        93 => 'Hong Kong',
        94 => 'Hungary',
        95 => 'Iceland',
        96 => 'India',
        97 => 'Indonesia',
        98 => 'Iran',
        99 => 'Iraq',
        100 => 'Ireland',
        224 => 'Isle of Man',
        101 => 'Israel',
        102 => 'Italy',
        103 => 'Ivory Coast',
        104 => 'Jamaica',
        105 => 'Japan',
        226 => 'Jersey',
        106 => 'Jordan',
        107 => 'Kazakhstan',
        108 => 'Kenya',
        109 => 'Kiribati Republic',
        242 => 'Kosovo',
        112 => 'Kuwait',
        113 => 'Kyrgyz Republic',
        114 => 'Laos',
        115 => 'Latvia',
        116 => 'Lebanon',
        117 => 'Lesotho',
        118 => 'Liberia',
        119 => 'Libya',
        120 => 'Liechtenstein',
        121 => 'Lithuania',
        122 => 'Luxembourg',
        123 => 'Macau',
        229 => 'Macedonia',
        124 => 'Madagascar',
        125 => 'Malawi',
        126 => 'Malaysia',
        127 => 'Maldives',
        128 => 'Mali',
        129 => 'Malta',
        130 => 'Marshall Islands',
        131 => 'Martinique',
        230 => 'Mauritius',
        132 => 'Mayotte Island',
        133 => 'Mexico',
        247 => 'Micronesia',
        134 => 'Moldova',
        135 => 'Monaco',
        136 => 'Mongolia',
        137 => 'Monserrat',
        234 => 'Montenegro',
        138 => 'Morocco',
        139 => 'Mozambique',
        140 => 'Myanmar',
        141 => 'Namibia',
        142 => 'Nauru',
        143 => 'Nepal',
        144 => 'Netherlands',
        145 => 'Netherlands Antilles',
        147 => 'New Caledonia',
        148 => 'New Zealand',
        149 => 'Nicaragua',
        150 => 'Niger',
        151 => 'Nigeria',
        152 => 'Niue',
        153 => 'Norfolk Island',
        110 => 'North Korea',
        238 => 'Northern Ireland',
        255 => 'Northern Marianas',
        154 => 'Norway',
        155 => 'Oman',
        156 => 'Pakistan',
        157 => 'Palau',
        235 => 'Palestine',
        158 => 'Panama',
        159 => 'Papua New Guinea',
        160 => 'Paraguay',
        161 => 'Peru',
        162 => 'Philippines',
        163 => 'Poland',
        164 => 'Portugal',
        165 => 'Puerto Rico',
        166 => 'Qatar',
        246 => 'Runion',
        167 => 'Romania',
        169 => 'Russia',
        170 => 'Rwanda',
        172 => 'Saipan Island',
        219 => 'Samoa',
        173 => 'San Marino',
        254 => 'So Tom & Principe',
        174 => 'Saudi Arabia',
        241 => 'Scotland',
        175 => 'Senegal Republic',
        221 => 'Serbia',
        245 => 'Seychelles',
        176 => 'Sierra Leone',
        177 => 'Singapore',
        178 => 'Slovak Republic',
        179 => 'Slovenia',
        180 => 'Solomon Islands',
        181 => 'Somalia',
        182 => 'South Africa',
        111 => 'South Korea',
        183 => 'Spain',
        184 => 'Sri Lanka',
        185 => 'St Helena',
        186 => 'St Kitts',
        171 => 'St Lucia',
        227 => 'St Vincent & The Grenadines',
        187 => 'Sudan',
        188 => 'Suriname',
        189 => 'Swaziland',
        190 => 'Sweden',
        191 => 'Switzerland',
        192 => 'Syria',
        193 => 'Taiwan',
        194 => 'Tajikistan',
        195 => 'Tanzania',
        196 => 'Thailand',
        237 => 'Tibet',
        197 => 'Tinian Island',
        198 => 'Togo',
        199 => 'Tokelau',
        200 => 'Tonga',
        201 => 'Trinidad & Tobago',
        202 => 'Tunisia',
        203 => 'Turkey',
        204 => 'Turkmenistan',
        205 => 'Turks and Caicos Islands',
        206 => 'Tuvalu',
        207 => 'Uganda',
        208 => 'Ukraine',
        209 => 'United Arab Emirates',
        211 => 'United States Virgin Islands',
        212 => 'Uruguay',
        214 => 'Uzbekistan',
        215 => 'Vanuatu',
        216 => 'Vatican City',
        217 => 'Venezuela',
        218 => 'Vietnam',
        239 => 'Wales',
        248 => 'Yemen',
        222 => 'Zambia',
        223 => 'Zimbabwe');
    }
    
    if (array_key_exists($BrewerCountryID , $country_names)) {
      return $country_names[ $BrewerCountryID  ];      
    }
    
    return 'NOT FOUND';
    
  }
  
}
